searchData={"items":[{"type":"module","title":"Rapport","doc":"Rapport aims to provide a robust set of modules to generate\nHTML reports that both looks good in the browser and when being printed.","ref":"Rapport.html"},{"type":"function","title":"Rapport.add_page/2","doc":"","ref":"Rapport.html#add_page/2"},{"type":"function","title":"Rapport.add_page/3","doc":"","ref":"Rapport.html#add_page/3"},{"type":"function","title":"Rapport.add_page_numbers/1","doc":"","ref":"Rapport.html#add_page_numbers/1"},{"type":"function","title":"Rapport.add_page_numbers/2","doc":"","ref":"Rapport.html#add_page_numbers/2"},{"type":"function","title":"Rapport.add_page_numbers/3","doc":"","ref":"Rapport.html#add_page_numbers/3"},{"type":"function","title":"Rapport.add_pages/2","doc":"","ref":"Rapport.html#add_pages/2"},{"type":"function","title":"Rapport.generate_html/1","doc":"Generates HTML for the report.","ref":"Rapport.html#generate_html/1"},{"type":"function","title":"Options - Rapport.generate_html/1","doc":"* `report` - The `Rapport.Report` that you want to generate to HTML.","ref":"Rapport.html#generate_html/1-options"},{"type":"function","title":"Rapport.generate_pages/2","doc":"","ref":"Rapport.html#generate_pages/2"},{"type":"function","title":"Rapport.generate_pages/3","doc":"","ref":"Rapport.html#generate_pages/3"},{"type":"function","title":"Rapport.new/2","doc":"Creates a new report.\n\nAn optional EEx template can be passed to the `new` function. This template\nis meant to hold global things like styles, fonts etc that can be used on all\npages thats added to the report.\n\nThe `new` function sets the default paper size to `:A4`, the rotation\nto `:portrait`, the page padding to 10mm and the report title to \"Report\".\nThose defaults can easily be overridden by using `set_paper_size/2`,\n`set_rotation/2`, `set_padding/2` and `set_title/2`.\n\nReturns a `Rapport.Report` struct.","ref":"Rapport.html#new/2"},{"type":"function","title":"Options - Rapport.new/2","doc":"* `template` - An optional EEx template for the report.\n  * `fields` - A map with fields to assign to the EEx report template","ref":"Rapport.html#new/2-options"},{"type":"function","title":"Rapport.save_to_file/2","doc":"Convenient function to save a report to file.","ref":"Rapport.html#save_to_file/2"},{"type":"function","title":"Options - Rapport.save_to_file/2","doc":"* `report` - The `Rapport.Report` that you want to save to a HTML file\n  * `file_path` - The path to the HTML file you want to save.","ref":"Rapport.html#save_to_file/2-options"},{"type":"function","title":"Rapport.set_padding/2","doc":"Sets the padding (in millimeters) for the report.\n\nIt expects the padding to be an integer and must be `10`, `15`, `20` or `25` mm,\notherwise `ArgumentError` will be raised.","ref":"Rapport.html#set_padding/2"},{"type":"function","title":"Options - Rapport.set_padding/2","doc":"* `report` - The `Rapport.Report` that you want set the padding for\n  * `rotation` - The padding.","ref":"Rapport.html#set_padding/2-options"},{"type":"function","title":"Rapport.set_paper_size/2","doc":"Sets the paper size for the report.\n\nIt expects the paper size to be an atom and must be\n`:A4`, `:A3`, `:A5`, `:half_letter`, `:letter`, `:legal`, `:junior_legal`\n or `:ledger`, otherwise `ArgumentError` will be raised.","ref":"Rapport.html#set_paper_size/2"},{"type":"function","title":"Options - Rapport.set_paper_size/2","doc":"* `report` - The `Rapport.Report` that you want set the paper size for\n  * `paper_size` - The paper size.","ref":"Rapport.html#set_paper_size/2-options"},{"type":"function","title":"Rapport.set_rotation/2","doc":"Sets the rotation for the report.\n\nIt expects the rotation to an atom and must be `:portrait` or `:landscape`,\notherwise `ArgumentError` will be raised.","ref":"Rapport.html#set_rotation/2"},{"type":"function","title":"Options - Rapport.set_rotation/2","doc":"*  `report` - The `Rapport.Report` that you want set the rotation for\n  *  `rotation` - The rotation.","ref":"Rapport.html#set_rotation/2-options"},{"type":"function","title":"Rapport.set_title/2","doc":"Sets the title for a report. This is the title of the generated html report.","ref":"Rapport.html#set_title/2"},{"type":"function","title":"Options - Rapport.set_title/2","doc":"* `report` - The `Rapport.Report` you want to set the title for.\n  * `title` - The new title","ref":"Rapport.html#set_title/2-options"},{"type":"module","title":"Rapport.Barcode","doc":"","ref":"Rapport.Barcode.html"},{"type":"function","title":"Rapport.Barcode.create/3","doc":"Creates a barcode image (PNG) with the given text\n\nIt expects the barcode type to be an :atom and it must be `:code39`, `:code93`, `code128` or `:itf`,\notherwise `ArgumentError` will be raised.","ref":"Rapport.Barcode.html#create/3"},{"type":"function","title":"Options - Rapport.Barcode.create/3","doc":"* `barcode_type` - The barcode type to use\n  * `text` - The text to use to generate the barcode","ref":"Rapport.Barcode.html#create/3-options"},{"type":"module","title":"Rapport.Font","doc":"","ref":"Rapport.Font.html"},{"type":"function","title":"Rapport.Font.as_data/1","doc":"Converts a font file (woff2) to a base64 encoded string that can be embedded:\n\n@font-face {\n  src: url(data:font/woff2;charset=utf-8;base64,d09GRgA...kAAA==) format('woff')\n}\n\nOnly woff2 format is supported at the moment","ref":"Rapport.Font.html#as_data/1"},{"type":"function","title":"Options - Rapport.Font.as_data/1","doc":"* `font` - Font binary","ref":"Rapport.Font.html#as_data/1-options"},{"type":"module","title":"Rapport.Image","doc":"","ref":"Rapport.Image.html"},{"type":"function","title":"Rapport.Image.as_data/1","doc":"Converts an image to a base64 encoded string that can be embedded in a image tag:\n\n \n\nSupported image types are JPEG, PNG and GIF.","ref":"Rapport.Image.html#as_data/1"},{"type":"function","title":"Options - Rapport.Image.as_data/1","doc":"* `image` - Image binary","ref":"Rapport.Image.html#as_data/1-options"},{"type":"module","title":"Rapport.Page","doc":"","ref":"Rapport.Page.html"},{"type":"function","title":"Rapport.Page.add_page/2","doc":"Adds a new page to a report.","ref":"Rapport.Page.html#add_page/2"},{"type":"function","title":"Options - Rapport.Page.add_page/2","doc":"* `report` - A `Rapport.Report` struct that you want to add the page to.\n  * `page` - A `Rapport.Page` struct","ref":"Rapport.Page.html#add_page/2-options"},{"type":"function","title":"Rapport.Page.add_page/3","doc":"Adds a new page to a report.","ref":"Rapport.Page.html#add_page/3"},{"type":"function","title":"Options - Rapport.Page.add_page/3","doc":"* `report` - A `Rapport.Report` struct that you want to add the page to.\n  * `page_template` - An EEx template for the page\n  * `fields` - A map with fields that must be assigned to the EEx template","ref":"Rapport.Page.html#add_page/3-options"},{"type":"function","title":"Rapport.Page.add_pages/2","doc":"Adds a list of pages to a report.","ref":"Rapport.Page.html#add_pages/2"},{"type":"function","title":"Options - Rapport.Page.add_pages/2","doc":"* `report` - A `Rapport.Report` struct that you want to add the page to.\n  * `pages` - A list with `Rapport.Page` structs","ref":"Rapport.Page.html#add_pages/2-options"},{"type":"type","title":"Rapport.Page.t/0","doc":"","ref":"Rapport.Page.html#t:t/0"},{"type":"module","title":"Rapport.PageNumbering","doc":"","ref":"Rapport.PageNumbering.html"},{"type":"function","title":"Rapport.PageNumbering.add_page_numbers/3","doc":"Adds page numbers to the pages\n\nIt expects the page position to be an atom and must be `:bottom_right`, `:bottom_left`, `:top_right` or `:top_left`,\notherwise `ArgumentError` will be raised.","ref":"Rapport.PageNumbering.html#add_page_numbers/3"},{"type":"function","title":"Options - Rapport.PageNumbering.add_page_numbers/3","doc":"* `report` - The `Rapport.Report` that you want set the padding for\n  * `page_number_position` - Where the page number will be positioned.","ref":"Rapport.PageNumbering.html#add_page_numbers/3-options"},{"type":"type","title":"Rapport.PageNumbering.t/0","doc":"","ref":"Rapport.PageNumbering.html#t:t/0"},{"type":"module","title":"Rapport.Report","doc":"","ref":"Rapport.Report.html"},{"type":"type","title":"Rapport.Report.padding/0","doc":"","ref":"Rapport.Report.html#t:padding/0"},{"type":"type","title":"Rapport.Report.paper_size/0","doc":"","ref":"Rapport.Report.html#t:paper_size/0"},{"type":"type","title":"Rapport.Report.rotation/0","doc":"","ref":"Rapport.Report.html#t:rotation/0"},{"type":"type","title":"Rapport.Report.t/0","doc":"","ref":"Rapport.Report.html#t:t/0"},{"type":"extras","title":"README","doc":"Rapport aims to provide a robust set of modules to generate HTML reports that both looks good in the browser and when being printed.\n\n[![Elixir CI](https://github.com/ricn/rapport/actions/workflows/elixir.yml/badge.svg)](https://github.com/ricn/rapport/actions/workflows/elixir.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/rapport.svg)](https://hex.pm/packages/rapport)\n[![Coverage Status](https://coveralls.io/repos/github/ricn/rapport/badge.svg?branch=master)](https://coveralls.io/github/ricn/rapport?branch=master)","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"The package can be installed\nby adding `rapport` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rapport, \"~> 0.7\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Notable features - README","doc":"* Specify paper size for the report\n  * Specify rotation for the report\n  * Image helpers\n  * Font helpers\n  * Page numbering\n  * Add custom styling & even Javascript\n  * Barcodes","ref":"readme.html#notable-features"},{"type":"extras","title":"Hello world - README","doc":"```elixir\npage_template = \" <%= @hello %> \"\nhtml_report =\n  Rapport.new\n  |> Rapport.add_page(page_template, %{hello: \"Hello world!\"})\n  |> Rapport.save_to_file(\"/home/users/ricn/hello.html\")\n```\n\nThe snippet above generates a report containing only one page with a heading that says \"Hello world!\".\n\n[See example here](https://rawgit.com/ricn/rapport/master/examples/hello.html)","ref":"readme.html#hello-world"},{"type":"extras","title":"More examples - README","doc":"* [Custom fonts and styling](https://rawgit.com/ricn/rapport/master/examples/custom_fonts_and_styles.html)\n  * [Invoice](https://rawgit.com/ricn/rapport/master/examples/invoice.html)\n  * [Page numbering](https://rawgit.com/ricn/rapport/master/examples/page_numbering.html)\n  * [List of people with cover page](https://rawgit.com/ricn/rapport/master/examples/list_of_people.html)\n  * [Barcodes](https://rawgit.com/ricn/rapport/master/examples/barcodes.html)\n  * More examples are coming...\n\nIf you want to see how the examples has been created, you can look at the `example_test.exs` file in the test folder.","ref":"readme.html#more-examples"},{"type":"extras","title":"Phoenix integration - README","doc":"It's easy to Integrate Rapport with Phoenix. Just load the template as a module attribute, create the HTML for the report\nand send a response with the generated HTML:\n\n```elixir\ndefmodule ReportsWeb.ReportController do\n  use ReportsWeb, :controller\n\n  @page_template File.read!(Path.join(__DIR__, \"../templates/report/hello.html.eex\"))\n\n  def hello(conn, _params) do\n    html_report =\n       Rapport.new\n       |> Rapport.add_page(@page_template, %{hello: \"Hello World!\"})\n       |> Rapport.generate_html\n\n       conn\n       |> put_resp_content_type(\"text/html\")\n       |> send_resp(200, html_report)\n  end\nend\n```","ref":"readme.html#phoenix-integration"},{"type":"extras","title":"Upcoming features - README","doc":"* Charts\n  * PDF conversion","ref":"readme.html#upcoming-features"},{"type":"extras","title":"Credits - README","doc":"The following people have contributed ideas, documentation, or code to Rapport:\n\n* Richard Nyström","ref":"readme.html#credits"},{"type":"extras","title":"Contributing - README","doc":"1. Fork it\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Commit your changes (`git commit -am 'Add some feature'`)\n4. Push to the branch (`git push origin my-new-feature`)\n5. Create new Pull Request","ref":"readme.html#contributing"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}